#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>

#include "vhtml.h"

Window findWindowByClassHintName(Display *display,Window root_window,char *name)
{
    XTextProperty
        window_name;

    Window
        child,
        *children,
        window;

    int
        i,
        number_children,
        rc;

    XClassHint
        classhint;


    if (XGetClassHint(display,root_window,&classhint))
    {
        if (classhint.res_name)
        {
            if (strcmp((char *)classhint.res_name,name) == 0)
            {
                return (root_window);
            }
        }
    }

   rc=XQueryTree(display,
           root_window,
           &child,
           &child,
           &children,
           &number_children);

   if (!rc)
   {
       (void) fprintf(stderr,"XQueryTree() failed\n");
       return ((Window) NULL);
   }

   window=(Window) NULL;
   for (i=0; i < number_children; i++)
   {
       window=findWindowByClassHintName(display,children[i],name);
       if (window != (Window) NULL)
               break;
   }
   if (children != (Window *) NULL)
       XFree((void *) children);

   return (window);
}

/* a name given find the window id */
/* return the window id on success, 0 on failure */
/* for netscape pass the name as "Navigator" */
int findWindowId(char *name)
{
    Display
        *display;

    Window
        child,
        *children,
        target_window,
        root_window;

    int
        i,
        number_children,
        rc;

    char
        *win_name;

   /* open the display */
   display=XOpenDisplay((char *) NULL);
   if (display == NULL)
   {
       (void) fprintf(stderr,"Could not open display\n");
       return (-1);
   }

   /* find root window */
   root_window=XRootWindow(display,XDefaultScreen(display));

   target_window=findWindowByClassHintName(display,root_window,"Navigator");
   return (target_window);
}

